<?php

/*
Plugin Name: Digg Digg
Version: 1.4.1
Plugin URI: http://www.mkyong.com/blog/digg-digg-wordpress-plugin
Author: Yong Mook Kim
Author URI: http://www.mkyong.com/
Description: Integrate "Digg Button" and "Reddit Me Button" Into Wordpress Content 

*/ 

/*
http://www.mkyong.com/blog/digg-digg-wordpress-plugin for any help ,support ,requests, suggestions or updates

This is my first Wordpress plugin, Thanks!
*/

/*http://codex.wordpress.org/Adding_Administration_Menus*/

/*
Change Log

Digg Digg v1.4.1 - 15/11/2008
-Bug fix for Display Right float , append "&" in button
-Bug fix for "Button Allow Display Options" is not working, button is not display in right position

Digg Digg v1.4 - 14/11/2008
-Add Support for Reddit me button
-Bug fix for digg submit, when click digg button, open a new windows.
-Add dd_digg for all digg's variables
-Add dd_reddit for all reditt's variables
-<?php if(function_exists('digg_digg_reddit_generate')) { digg_digg_reddit_generate(); } ?>
-<?php if(function_exists('digg_digg_generate')) { digg_digg_generate(); } ?>

Digg Digg v1.3 - 01/11/2008
-Bug fix for digg submit, didnt include post title (thanks Byron)
-Add digg_digg prefix to every variables and methods
-Choose Digg Button Design - normal, compact or icon

Digg Digg v1.2 - 05/09/2008
Add Digg Button Control Display function Setup Screen.
-Display at Home page
-Display at Static page
-Display at Post Page
-Display at Category Page
-Display at Archive Page

Digg Digg v1.1 - 31/07/2008
Add Setup screen (SettingC>DiggDigg) to let user choose where user want to display Digg button.
1)Append Digg Button with Left Float Content
2)Append Digg Button with Right Float Content
3)Append Digg Button Before Content
4)Append Digg Button After Content

*/
		
//hook hook
add_action('admin_menu', 'digg_digg_admin_menu');
add_filter('the_content', 'digg_digg_content_hook');

if(!get_option('dd_digg_appendType')){
	digg_digg_resetIt();
}

function digg_digg_resetIt(){
	
        delete_option('dd_digg_appendType');
        update_option('dd_digg_buttonDesign',"normal");
		update_option('dd_digg_display_home', "checked=on");
        update_option('dd_digg_display_page', "checked=on");
        update_option('dd_digg_display_post', "checked=on");
        update_option('dd_digg_display_cat', "checked=on");
        update_option('dd_digg_display_archive', "checked=on");
		
		delete_option('dd_reddit_appendType');
        update_option('dd_reddit_buttonDesign',"normal");
		update_option('dd_reddit_display_home', "checked=on");
        update_option('dd_reddit_display_page', "checked=on");
        update_option('dd_reddit_display_post', "checked=on");
        update_option('dd_reddit_display_cat', "checked=on");
        update_option('dd_reddit_display_archive', "checked=on");
		
}

function digg_digg_admin_menu() {
	add_submenu_page('options-general.php', 'Digg Digg Options', 'Digg Digg', 8, 'digg-digg', 'digg_digg_menu');
}

function digg_digg_menu(){
   
  if ($_REQUEST['digg_digg_save']) {
	  
	    //digg.com
		update_option('dd_digg_appendType', $_REQUEST['dd_digg_appendType']);		
        update_option('dd_digg_buttonDesign', $_REQUEST['dd_digg_buttonDesign']);

        if($_POST['dd_digg_home'] == "on") update_option('dd_digg_display_home', "checked=on");
        else update_option('dd_digg_display_home', "");

        if($_POST['dd_digg_page'] == "on") update_option('dd_digg_display_page', "checked=on");
        else update_option('dd_digg_display_page', "");

        if($_POST['dd_digg_post'] == "on") update_option('dd_digg_display_post', "checked=on");
        else update_option('dd_digg_display_post', "");

        if($_POST['dd_digg_cat'] == "on") update_option('dd_digg_display_cat', "checked=on");
        else update_option('dd_digg_display_cat', "");

        if($_POST['dd_digg_archive'] == "on") update_option('dd_digg_display_archive', "checked=on");
        else update_option('dd_digg_display_archive', "");

		//reddit.com
		update_option('dd_reddit_appendType', $_REQUEST['dd_reddit_appendType']);		
        update_option('dd_reddit_buttonDesign', $_REQUEST['dd_reddit_buttonDesign']);

        if($_POST['dd_reddit_home'] == "on") update_option('dd_reddit_display_home', "checked=on");
        else update_option('dd_reddit_display_home', "");

        if($_POST['dd_reddit_page'] == "on") update_option('dd_reddit_display_page', "checked=on");
        else update_option('dd_reddit_display_page', "");

        if($_POST['dd_reddit_post'] == "on") update_option('dd_reddit_display_post', "checked=on");
        else update_option('dd_reddit_display_post', "");

        if($_POST['dd_reddit_cat'] == "on") update_option('dd_reddit_display_cat', "checked=on");
        else update_option('dd_reddit_display_cat', "");

        if($_POST['dd_reddit_archive'] == "on") update_option('dd_reddit_display_archive', "checked=on");
        else update_option('dd_reddit_display_archive', "");
		
		echo '<div id="message" class="updated fade"><p>Saved changes.</p></div>';

  }  else if($_REQUEST['digg_digg_clear']){
	
        digg_digg_resetIt();

		echo '<div id="message" class="error fade"><p>Plugin cleared.</p></div>';
			
  }

  // load options from db to display
  $dd_digg_appendType = get_option('dd_digg_appendType');
  $dd_digg_buttonDesign = get_option('dd_digg_buttonDesign');
  
  $dd_reddit_appendType = get_option('dd_reddit_appendType');
  $dd_reddit_buttonDesign = get_option('dd_reddit_buttonDesign');
  
  // display options
  print_digg_digg_menu_form($dd_digg_appendType,$dd_digg_buttonDesign,$dd_reddit_appendType,$dd_reddit_buttonDesign);
}

function print_digg_digg_menu_form($dd_digg_appendType='',$dd_digg_buttonDesign='',$dd_reddit_appendType='',$dd_reddit_buttonDesign=''){
?>

<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post" id="digg_digg_diggform" name="digg_digg_diggform">

<div class="wrap" id="digg_digg_options">
<fieldset>

<h2>Digg Digg Plugin Setup</h2>

<table width="100%">
<tr><td width="50%">

<div class="wrap">
<h2>Digg.com</h2>

<h3>Digg Button Append Options</h3>

<p>Select where the Digg button you want to integrate into wordpress content</p>

<p>
<select name="dd_digg_appendType">
<option value="none"<?php echo ($dd_digg_appendType=="none") ? " selected" : ""; ?>>--None--</option>
<option value="left_float"<?php echo ($dd_digg_appendType=="left_float") ? " selected" : ""; ?>>Left Float Type</option>
<option value="right_float"<?php echo ($dd_digg_appendType=="right_float") ? " selected" : ""; ?>>Right Float Type</option>
<option value="before_content"<?php echo ($dd_digg_appendType=="before_content") ? " selected" : ""; ?>>Before Content Type</option>
<option value="after_content"<?php echo ($dd_digg_appendType=="after_content") ? " selected" : ""; ?>>After Content Type</option>
</select> 
</p>

<h3>Digg Button Allow Display Options </h3>

<p>Digg button allow to display in home? category page? post page? Check all if you want to display everywhere</p>

<p>

<INPUT TYPE=CHECKBOX NAME="dd_digg_home" <?php echo get_option('dd_digg_display_home'); ?>>home page<BR> 
<INPUT TYPE=CHECKBOX NAME="dd_digg_page" <?php echo get_option('dd_digg_display_page'); ?>>static pages<BR>
<INPUT TYPE=CHECKBOX NAME="dd_digg_post" <?php echo get_option('dd_digg_display_post'); ?>>post pages<BR>
<INPUT TYPE=CHECKBOX NAME="dd_digg_cat" <?php echo get_option('dd_digg_display_cat'); ?>>category pages<BR>
<INPUT TYPE=CHECKBOX NAME="dd_digg_archive" <?php echo get_option('dd_digg_display_archive'); ?>>archive pages<BR>
</p>


<h3>Digg Button Design Options</h3>

<p>Select the Digg button design</p>

<p>
<select name="dd_digg_buttonDesign">
<option value="normal"<?php echo ($dd_digg_buttonDesign=="normal") ? " selected" : ""; ?>>Normal</option>
<option value="compact"<?php echo ($dd_digg_buttonDesign=="compact") ? " selected" : ""; ?>>Compact</option>
<option value="icon"<?php echo ($dd_digg_buttonDesign=="icon") ? " selected" : ""; ?>>Icon</option>
</select> 
</p>
</div>
</td>

<td width="50%">


<div class="wrap">
<h2>Reddit.com</h2>

<h3>Reddit Button Append Options</h3>

<p>Select where the Reddit button you want to integrate into wordpress content</p>

<p>
<select name="dd_reddit_appendType">
<option value="none"<?php echo ($dd_reddit_appendType=="none") ? " selected" : ""; ?>>--None--</option>
<option value="left_float"<?php echo ($dd_reddit_appendType=="left_float") ? " selected" : ""; ?>>Left Float Type</option>
<option value="right_float"<?php echo ($dd_reddit_appendType=="right_float") ? " selected" : ""; ?>>Right Float Type</option>
<option value="before_content"<?php echo ($dd_reddit_appendType=="before_content") ? " selected" : ""; ?>>Before Content Type</option>
<option value="after_content"<?php echo ($dd_reddit_appendType=="after_content") ? " selected" : ""; ?>>After Content Type</option>
</select> 
</p>

<h3>Reddit Button Allow Display Options </h3>

<p>Reddit button allow to display in home? category page? post page? Check all if you want to display everywhere</p>

<p>

<INPUT TYPE=CHECKBOX NAME="dd_reddit_home" <?php echo get_option('dd_reddit_display_home'); ?>>home page<BR> 
<INPUT TYPE=CHECKBOX NAME="dd_reddit_page" <?php echo get_option('dd_reddit_display_page'); ?>>static pages<BR>
<INPUT TYPE=CHECKBOX NAME="dd_reddit_post" <?php echo get_option('dd_reddit_display_post'); ?>>post pages<BR>
<INPUT TYPE=CHECKBOX NAME="dd_reddit_cat" <?php echo get_option('dd_reddit_display_cat'); ?>>category pages<BR>
<INPUT TYPE=CHECKBOX NAME="dd_reddit_archive" <?php echo get_option('dd_reddit_display_archive'); ?>>archive pages<BR>
</p>


<h3>Reddit Button Design Options</h3>

<p>Select the Reddit button design</p>

<p>
<select name="dd_reddit_buttonDesign">
<option value="normal"<?php echo ($dd_reddit_buttonDesign=="normal") ? " selected" : ""; ?>>Normal</option>
<option value="compact"<?php echo ($dd_reddit_buttonDesign=="compact") ? " selected" : ""; ?>>Compact</option>
<option value="icon"<?php echo ($dd_reddit_buttonDesign=="icon") ? " selected" : ""; ?>>Icon</option>
</select> 
</p>
</div>


<td></tr>

<tr>
<td width="50%">
</td>
<td width="50%"></td>
</tr>


</table>

</fieldset>


<p class="submit"><input name="digg_digg_clear" id="reset" style='width:150px' value="Reset Options" type="submit" />
<input name="digg_digg_save" id="save" style='width:150px' value="Save Changes" type="submit" /></p>
</div>
</form>

<?php
}

function digg_digg_content_hook($content = ''){

     if(is_home() && !get_option('dd_digg_display_home') == 'checked=on' && !get_option('dd_reddit_display_home') == 'checked=on')
           return $content;
     if(is_page() && !get_option('dd_digg_display_page') == 'checked=on' && !get_option('dd_reddit_display_page') == 'checked=on')
           return $content;
     if(is_single() && !get_option('dd_digg_display_post') == 'checked=on' && !get_option('dd_reddit_display_post') == 'checked=on')
           return $content;
     if(is_category() && !get_option('dd_digg_display_cat') == 'checked=on' && !get_option('dd_reddit_display_cat') == 'checked=on')
           return $content;
     if(is_archive() && !get_option('dd_digg_display_archive') == 'checked=on' && !is_category() && !get_option('dd_reddit_display_archive') == 'checked=on')
           return $content; 
	
     $dd_digg_display =true;
     $dd_reddit_display =true;

     if(is_home() && !get_option('dd_digg_display_home') == 'checked=on')
           $dd_digg_display = false;
     if(is_page() && !get_option('dd_digg_display_page') == 'checked=on')
           $dd_digg_display = false;
     if(is_single() && !get_option('dd_digg_display_post') == 'checked=on')
           $dd_digg_display = false;
     if(is_category() && !get_option('dd_digg_display_cat') == 'checked=on')
           $dd_digg_display = false;
     if(is_archive() && !get_option('dd_digg_display_archive') == 'checked=on' && !is_category())
           $dd_digg_display = false;

     if(is_home() && !get_option('dd_reddit_display_home') == 'checked=on')
	     $dd_reddit_display =false;
     if(is_page() && !get_option('dd_reddit_display_page') == 'checked=on')
	     $dd_reddit_display =false;
     if(is_single() && !get_option('dd_reddit_display_post') == 'checked=on')
	     $dd_reddit_display =false;
     if(is_category() && !get_option('dd_reddit_display_cat') == 'checked=on')
	     $dd_reddit_display =false;
     if(is_archive() && !get_option('dd_reddit_display_archive') == 'checked=on' && !is_category())
	     $dd_reddit_display =false;


     $result = "";
     global $wp_query; 
     $post = $wp_query->post;
     $id = $post->ID;
     $postlink = get_permalink($id);
     $title = urlencode($post->post_title);

     $digglink = split('#',$postlink);

     $dd_digg_appendType = get_option('dd_digg_appendType');
	 $dd_reddit_appendType = get_option('dd_reddit_appendType');
	 
     $dd_digg_design = get_option('dd_digg_buttonDesign');
	 $dd_reddit_design = get_option('dd_reddit_buttonDesign');
	

	 //digg
     if($dd_digg_design == 'normal')
          $dd_digg_design .=  "' height='80' width='52'";

     if($dd_digg_design == 'compact')
          $dd_digg_design .=  "' height='18' width='120'";

     if($dd_digg_design == 'icon')
          $dd_digg_design .=  "' height='16' width='16'";

	 //reddit
	 if($dd_reddit_design == 'normal')
          $dd_reddit_design =  "&t=2 ' height='80' width='52'";

     if($dd_reddit_design == 'compact')
          $dd_reddit_design =  "&t=1 ' height='18' width='120'";

     if($dd_reddit_design == 'icon')
          $dd_reddit_design =  "&t=3 ' height='80' width='65'";
 
       $dd_digg_iframe = "<iframe src='http://digg.com/api/diggthis.php?w=new&u=" .htmlspecialchars($digglink[0]) . "&t=" . $title . "&s=" . $dd_digg_design . "' frameborder='0' scrolling='no'></iframe>";

	$dd_reddit_iframe = "<iframe src='http://www.reddit.com/button_content?newwindow=1&url=" .htmlspecialchars($digglink[0]) . "&title=" . $title . $dd_reddit_design .  " scrolling='no' frameborder='0' ></iframe>";
	 
	$dd_left_flag = false;
	$dd_right_flag = false;
	$dd_before_flag = false;
	$dd_after_flag = false;
	
	//left float
	 $dd_left_float = "<div style='float:left'><br>" ;

	 if($dd_digg_appendType=='left_float' && $dd_digg_display ==true){
		 $dd_left_float .= ' ' . $dd_digg_iframe;
		 $dd_left_flag = true;
	 }
	 
	 if($dd_reddit_appendType=='left_float' && $dd_reddit_display =true){
		 $dd_left_float .= ' ' . $dd_reddit_iframe;
		 $dd_left_flag = true;
	 }
	 $dd_left_float .= "</div>";
		  
	//right float 
	 $dd_right_float = "<div style='float:right'><br>" ;
	 
	 if($dd_digg_appendType=='right_float'  && $dd_digg_display ==true){
		 $dd_right_float .= ' ' . $dd_digg_iframe;
		 $dd_right_flag = true;
	 }
	 
	 if($dd_reddit_appendType=='right_float' && $dd_reddit_display =true){
		 $dd_right_float .= ' ' . $dd_reddit_iframe;
		 $dd_right_flag = true;
	 }
	 $dd_right_float .= "</div>";
		  
	//before content
	 $dd_before_content = "<div><br>" ;
	 
	 if($dd_digg_appendType=='before_content'  && $dd_digg_display ==true){
		 $dd_before_content .= ' ' . $dd_digg_iframe;
		 $dd_before_flag = true;
	 }
	 
	 if($dd_reddit_appendType=='before_content' && $dd_reddit_display =true){
		 $dd_before_content .= ' ' . $dd_reddit_iframe;
		 $dd_before_flag = true;
	 }
	 $dd_before_content .= "</div>";
	 
	 //after content
	 $dd_after_content = "<div><br>" ;
	 
	 if($dd_digg_appendType=='after_content'  && $dd_digg_display ==true){
		 $dd_after_content .= ' ' . $dd_digg_iframe;
		 $dd_after_flag = true;
	 }
	 
	 if($dd_reddit_appendType=='after_content' && $dd_reddit_display =true){
		 $dd_after_content .= ' ' . $dd_reddit_iframe;
		 $dd_after_flag = true;
	 }
	 $dd_after_content .= "</div>";
	 
 
	if($dd_left_flag == true)
		$content = $dd_left_float . $content;
	
	if($dd_right_flag == true)
		$content = $dd_right_float . $content;
	
	if($dd_before_flag == true)
		$content = $dd_before_content . $content;
	
	if($dd_after_flag == true)
		$content = $content . $dd_after_content;
	
     return $content;
}

//function to gernerate digg button
function digg_digg_generate()
{
	$result = "";
	global $wp_query; 
	$post = $wp_query->post;
	$id = $post->ID;
	$postlink = get_permalink($id);
       
	$title = urlencode($post->post_title);

	$digglink = split('#',$postlink);

    $dd_digg_design = get_option('digg_digg_buttonDesign');
   
	//digg
	 if($dd_digg_design == 'normal')
		 $dd_digg_design .=  "' height='80' width='52'";

	 if($dd_digg_design == 'compact')
		  $dd_digg_design .=  "' height='18' width='120'";

	 if($dd_digg_design == 'icon')
		  $dd_digg_design .=  "' height='16' width='16'";

    $result = "<iframe src='http://digg.com/api/diggthis.php?w=new&u=" .htmlspecialchars($digglink[0]) . "&t=" . $title . "&s=" . $dd_digg_design . "' frameborder='0' scrolling='no'></iframe>";
      
  	echo $result;
}  


//function to gernerate reddit button
function digg_digg_reddit_generate()
{
	$result = "";
	global $wp_query; 
	$post = $wp_query->post;
	$id = $post->ID;
	$postlink = get_permalink($id);
       
	$title = urlencode($post->post_title);

	$digglink = split('#',$postlink);

    $dd_reddit_design = get_option('dd_reddit_buttonDesign');
 
	 //reddit
	 if($dd_reddit_design == 'normal')
          $dd_reddit_design =  "&t=2 ' height='80' width='52'";

     if($dd_reddit_design == 'compact')
          $dd_reddit_design =  "&t=1 ' height='18' width='120'";

     if($dd_reddit_design == 'icon')
          $dd_reddit_design =  "&t=3 ' height='80' width='65'";
 
   $result = "<iframe src='http://www.reddit.com/button_content?newwindow=1&url=" . htmlspecialchars($digglink[0]) . "&title=" . $title . $dd_reddit_design .  " scrolling='no' frameborder='0' ></iframe>";
	
  	echo $result;
}  



?>